texmath-0.13.1.2: Conversion between math formats.

Safe Haskell | None
Language | Haskell2010

Text.TeXMath.Types

Description

Types for representing a structured formula.

Synopsis

- data Exp
  - = ENumber Text
  - | EGrouped [Exp]
  - | EDelimited Text Text [InEDelimited]
  - | EIdentifier Text
  - | EMathOperator Text
  - | ESymbol TeXSymbolType Text
  - | ESpace Rational
  - | ESub Exp Exp
  - | ESuper Exp Exp
  - | ESubsup Exp Exp Exp
  - | EOver Bool Exp Exp
  - | EUnder Bool Exp Exp
  - | EUnderover Bool Exp Exp Exp
  - | EPhantom Exp
  - | EBoxed Exp
  - | ECancel StrokeType Exp
  - | EFraction FractionType Exp Exp
  - | ERoot Exp Exp
  - | ESqrt Exp
  - | EScaled Rational Exp
  - | EArray [Alignment] [ArrayLine]
  - | EText TextType Text
  - | EStyled TextType [Exp]
- data TeXSymbolType
  - = Ord
  - | Op
  - | Bin
  - | Rel
  - | Open
  - | Close
  - | Pun
  - | Accent
  - | Fence
  - | TOver
  - | TUnder
  - | Alpha
  - | BotAccent
  - | Rad
- type ArrayLine = [[Exp]]
- data FractionType
  - = NormalFrac
  - | DisplayFrac
  - | InlineFrac
  - | NoLineFrac
- data TextType
  - = TextNormal
  - | TextBold
  - | TextItalic
  - | TextMonospace
  - | TextSansSerif
  - | TextDoubleStruck
  - | TextScript
  - | TextFraktur
  - | TextBoldItalic
  - | TextSansSerifBold
  - | TextSansSerifBoldItalic
  - | TextBoldScript
  - | TextBoldFraktur
  - | TextSansSerifItalic
- data Alignment
  - = AlignLeft
  - | AlignCenter
  - | AlignRight
- data DisplayType
  - = DisplayBlock
  - | DisplayInline
- data Operator = Operator {
  - oper :: Text
  - description :: Text
  - form :: FormType
  - priority :: Int
  - lspace :: Int
  - rspace :: Int
  - properties :: [Property]
  }
- data FormType
  - = FPrefix
  - | FPostfix
  - | FInfix
- data Record = Record {
  - uchar :: Char
  - commands :: [(Text, Text)]
  - category :: TeXSymbolType
  - comments :: Text
  }
- type Property = Text
- data Position
  - = Under
  - | Over
- data StrokeType
  - = ForwardSlash
  - | BackSlash
  - | XSlash
- type Env = [Text]
- defaultEnv :: [Text]
- type InEDelimited = Either Middle Exp

# Documentation

data Exp Source #

Constructors

ENumber Text | A number (`<mn>` in MathML).
EGrouped [Exp] | A group of expressions that function as a unit (e.g. `{...}`) in TeX, `<mrow>...</mrow>` in MathML.
EDelimited Text Text [InEDelimited] | A group of expressions inside paired open and close delimiters (which may in some cases be null).
EIdentifier Text | An identifier, e.g. a variable (`<mi>...</mi>` in MathML. Note that MathML tends to use `<mi>` tags for "sin" and other mathematical operators; these are represented as `EMathOperator` in TeXMath.
EMathOperator Text | A spelled-out operator like `lim` or `sin`.
ESymbol TeXSymbolType Text | A symbol.
ESpace Rational | A space, with the width specified in em.
ESub Exp Exp | An expression with a subscript. First argument is base, second subscript.
ESuper Exp Exp | An expresion with a superscript. First argument is base, second subscript.
ESubsup Exp Exp Exp | An expression with both a sub and a superscript. First argument is base, second subscript, third superscript.
EOver Bool Exp Exp | An expression with something over it. The first argument is True if the formula is "convertible:" that is, if the material over the formula should appear as a regular superscript in inline math. The second argument is the base, the third the expression that goes over it.
EUnder Bool Exp Exp | An expression with something under it. The arguments work as in `EOver`.
EUnderover Bool Exp Exp Exp | An expression with something over and something under it.
EPhantom Exp | A "phantom" operator that takes space but doesn't display.
EBoxed Exp | A boxed expression.
ECancel StrokeType Exp | A cancelled expression.
EFraction FractionType Exp Exp | A fraction. First argument is numerator, second denominator.
ERoot Exp Exp | An nth root. First argument is index, second is base.
ESqrt Exp | A square root.
EScaled Rational Exp | An expression that is scaled to some factor of its normal size.
EArray [Alignment] [ArrayLine] | An array or matrix. The first argument specifies the alignments of the columns; the second gives the contents of the lines. All of these lists should be the same length.
EText TextType Text | Some normal text, possibly styled.
EStyled TextType [Exp] | A group of styled expressions.

#### Instances

Instances details

Data Exp Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Exp -> c Exp Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Exp Source #

toConstr :: Exp -> Constr Source #

dataTypeOf :: Exp -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Exp) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Exp) Source #

gmapT :: (forall b. Data b => b -> b) -> Exp -> Exp Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Exp -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Exp -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Exp -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Exp -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Exp -> m Exp Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Exp -> m Exp Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Exp -> m Exp Source #

Read Exp Source # |
Instance details Defined in Text.TeXMath.Types Methods readsPrec :: Int -> ReadS Exp Source # readList :: ReadS [Exp] Source # readPrec :: ReadPrec Exp Source # readListPrec :: ReadPrec [Exp] Source #
Show Exp Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> Exp -> ShowS Source # show :: Exp -> String Source # showList :: [Exp] -> ShowS Source #
Eq Exp Source # |
Instance details Defined in Text.TeXMath.Types Methods (==) :: Exp -> Exp -> Bool Source # (/=) :: Exp -> Exp -> Bool Source #
Ord Exp Source # |
Instance details Defined in Text.TeXMath.Types Methods compare :: Exp -> Exp -> Ordering Source # (<) :: Exp -> Exp -> Bool Source # (<=) :: Exp -> Exp -> Bool Source # (>) :: Exp -> Exp -> Bool Source # (>=) :: Exp -> Exp -> Bool Source # max :: Exp -> Exp -> Exp Source # min :: Exp -> Exp -> Exp Source #

data TeXSymbolType Source #

Constructors

Ord |
Op |
Bin |
Rel |
Open |
Close |
Pun |
Accent |
Fence |
TOver |
TUnder |
Alpha |
BotAccent |
Rad |

#### Instances

Instances details

Data TeXSymbolType Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> TeXSymbolType -> c TeXSymbolType Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c TeXSymbolType Source #

toConstr :: TeXSymbolType -> Constr Source #

dataTypeOf :: TeXSymbolType -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c TeXSymbolType) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c TeXSymbolType) Source #

gmapT :: (forall b. Data b => b -> b) -> TeXSymbolType -> TeXSymbolType Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> TeXSymbolType -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> TeXSymbolType -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> TeXSymbolType -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> TeXSymbolType -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> TeXSymbolType -> m TeXSymbolType Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> TeXSymbolType -> m TeXSymbolType Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> TeXSymbolType -> m TeXSymbolType Source #

Read TeXSymbolType Source # |
Instance details Defined in Text.TeXMath.Types Methods readsPrec :: Int -> ReadS TeXSymbolType Source # readList :: ReadS [TeXSymbolType] Source # readPrec :: ReadPrec TeXSymbolType Source # readListPrec :: ReadPrec [TeXSymbolType] Source #
Show TeXSymbolType Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> TeXSymbolType -> ShowS Source # show :: TeXSymbolType -> String Source # showList :: [TeXSymbolType] -> ShowS Source #
Eq TeXSymbolType Source # |
Instance details Defined in Text.TeXMath.Types Methods (==) :: TeXSymbolType -> TeXSymbolType -> Bool Source # (/=) :: TeXSymbolType -> TeXSymbolType -> Bool Source #
Ord TeXSymbolType Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

compare :: TeXSymbolType -> TeXSymbolType -> Ordering Source #

(<) :: TeXSymbolType -> TeXSymbolType -> Bool Source #

(<=) :: TeXSymbolType -> TeXSymbolType -> Bool Source #

(>) :: TeXSymbolType -> TeXSymbolType -> Bool Source #

(>=) :: TeXSymbolType -> TeXSymbolType -> Bool Source #

max :: TeXSymbolType -> TeXSymbolType -> TeXSymbolType Source #

min :: TeXSymbolType -> TeXSymbolType -> TeXSymbolType Source #

type ArrayLine = [[Exp]] Source #

data FractionType Source #

Constructors

NormalFrac | Displayed or textual, acc to `DisplayType`
DisplayFrac | Force display mode
InlineFrac | Force inline mode (textual)
NoLineFrac | No line between top and bottom

#### Instances

Instances details

Data FractionType Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> FractionType -> c FractionType Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c FractionType Source #

toConstr :: FractionType -> Constr Source #

dataTypeOf :: FractionType -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c FractionType) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c FractionType) Source #

gmapT :: (forall b. Data b => b -> b) -> FractionType -> FractionType Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> FractionType -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> FractionType -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> FractionType -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> FractionType -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> FractionType -> m FractionType Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> FractionType -> m FractionType Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> FractionType -> m FractionType Source #

Read FractionType Source # |
Instance details Defined in Text.TeXMath.Types Methods readsPrec :: Int -> ReadS FractionType Source # readList :: ReadS [FractionType] Source # readPrec :: ReadPrec FractionType Source # readListPrec :: ReadPrec [FractionType] Source #
Show FractionType Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> FractionType -> ShowS Source # show :: FractionType -> String Source # showList :: [FractionType] -> ShowS Source #
Eq FractionType Source # |
Instance details Defined in Text.TeXMath.Types Methods (==) :: FractionType -> FractionType -> Bool Source # (/=) :: FractionType -> FractionType -> Bool Source #
Ord FractionType Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

compare :: FractionType -> FractionType -> Ordering Source #

(<) :: FractionType -> FractionType -> Bool Source #

(<=) :: FractionType -> FractionType -> Bool Source #

(>) :: FractionType -> FractionType -> Bool Source #

(>=) :: FractionType -> FractionType -> Bool Source #

max :: FractionType -> FractionType -> FractionType Source #

min :: FractionType -> FractionType -> FractionType Source #

data TextType Source #

Constructors

TextNormal |
TextBold |
TextItalic |
TextMonospace |
TextSansSerif |
TextDoubleStruck |
TextScript |
TextFraktur |
TextBoldItalic |
TextSansSerifBold |
TextSansSerifBoldItalic |
TextBoldScript |
TextBoldFraktur |
TextSansSerifItalic |

#### Instances

Instances details

Data TextType Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> TextType -> c TextType Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c TextType Source #

toConstr :: TextType -> Constr Source #

dataTypeOf :: TextType -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c TextType) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c TextType) Source #

gmapT :: (forall b. Data b => b -> b) -> TextType -> TextType Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> TextType -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> TextType -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> TextType -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> TextType -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> TextType -> m TextType Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> TextType -> m TextType Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> TextType -> m TextType Source #

Read TextType Source # |
Instance details Defined in Text.TeXMath.Types Methods readsPrec :: Int -> ReadS TextType Source # readList :: ReadS [TextType] Source # readPrec :: ReadPrec TextType Source # readListPrec :: ReadPrec [TextType] Source #
Show TextType Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> TextType -> ShowS Source # show :: TextType -> String Source # showList :: [TextType] -> ShowS Source #
Eq TextType Source # |
Instance details Defined in Text.TeXMath.Types Methods (==) :: TextType -> TextType -> Bool Source # (/=) :: TextType -> TextType -> Bool Source #
Ord TextType Source # |
Instance details Defined in Text.TeXMath.Types Methods compare :: TextType -> TextType -> Ordering Source # (<) :: TextType -> TextType -> Bool Source # (<=) :: TextType -> TextType -> Bool Source # (>) :: TextType -> TextType -> Bool Source # (>=) :: TextType -> TextType -> Bool Source # max :: TextType -> TextType -> TextType Source # min :: TextType -> TextType -> TextType Source #

data Alignment Source #

Constructors

AlignLeft |
AlignCenter |
AlignRight |

#### Instances

Instances details

Data Alignment Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Alignment -> c Alignment Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Alignment Source #

toConstr :: Alignment -> Constr Source #

dataTypeOf :: Alignment -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Alignment) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Alignment) Source #

gmapT :: (forall b. Data b => b -> b) -> Alignment -> Alignment Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Alignment -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Alignment -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Alignment -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Alignment -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Alignment -> m Alignment Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Alignment -> m Alignment Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Alignment -> m Alignment Source #

Read Alignment Source # |
Instance details Defined in Text.TeXMath.Types Methods readsPrec :: Int -> ReadS Alignment Source # readList :: ReadS [Alignment] Source # readPrec :: ReadPrec Alignment Source # readListPrec :: ReadPrec [Alignment] Source #
Show Alignment Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> Alignment -> ShowS Source # show :: Alignment -> String Source # showList :: [Alignment] -> ShowS Source #
Eq Alignment Source # |
Instance details Defined in Text.TeXMath.Types Methods (==) :: Alignment -> Alignment -> Bool Source # (/=) :: Alignment -> Alignment -> Bool Source #
Ord Alignment Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

compare :: Alignment -> Alignment -> Ordering Source #

(<) :: Alignment -> Alignment -> Bool Source #

(<=) :: Alignment -> Alignment -> Bool Source #

(>) :: Alignment -> Alignment -> Bool Source #

(>=) :: Alignment -> Alignment -> Bool Source #

max :: Alignment -> Alignment -> Alignment Source #

min :: Alignment -> Alignment -> Alignment Source #

data DisplayType Source #

Constructors

DisplayBlock | A displayed formula.
DisplayInline | A formula rendered inline in text.

#### Instances

Instances details

Show DisplayType Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> DisplayType -> ShowS Source # show :: DisplayType -> String Source # showList :: [DisplayType] -> ShowS Source #
Eq DisplayType Source # |
Instance details Defined in Text.TeXMath.Types Methods (==) :: DisplayType -> DisplayType -> Bool Source # (/=) :: DisplayType -> DisplayType -> Bool Source #
Ord DisplayType Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

compare :: DisplayType -> DisplayType -> Ordering Source #

(<) :: DisplayType -> DisplayType -> Bool Source #

(<=) :: DisplayType -> DisplayType -> Bool Source #

(>) :: DisplayType -> DisplayType -> Bool Source #

(>=) :: DisplayType -> DisplayType -> Bool Source #

max :: DisplayType -> DisplayType -> DisplayType Source #

min :: DisplayType -> DisplayType -> DisplayType Source #

data Operator Source #

A record of the MathML dictionary as defined in the specification

Constructors

Operator |

Fields

- oper :: Text

  Operator

- description :: Text

  Plain English Description

- form :: FormType

  Whether Prefix, Postfix or Infix

- priority :: Int

  Default priority for implicit nesting

- lspace :: Int

  Default Left Spacing

- rspace :: Int

  Default Right Spacing

- properties :: [Property]

  List of MathML properties

#### Instances

Instances details

Show Operator Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> Operator -> ShowS Source # show :: Operator -> String Source # showList :: [Operator] -> ShowS Source #

data FormType Source #

Constructors

FPrefix |
FPostfix |
FInfix |

#### Instances

Instances details

Show FormType Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> FormType -> ShowS Source # show :: FormType -> String Source # showList :: [FormType] -> ShowS Source #
Eq FormType Source # |
Instance details Defined in Text.TeXMath.Types Methods (==) :: FormType -> FormType -> Bool Source # (/=) :: FormType -> FormType -> Bool Source #
Ord FormType Source # |
Instance details Defined in Text.TeXMath.Types Methods compare :: FormType -> FormType -> Ordering Source # (<) :: FormType -> FormType -> Bool Source # (<=) :: FormType -> FormType -> Bool Source # (>) :: FormType -> FormType -> Bool Source # (>=) :: FormType -> FormType -> Bool Source # max :: FormType -> FormType -> FormType Source # min :: FormType -> FormType -> FormType Source #

data Record Source #

A record of the Unicode to LaTeX lookup table a full descripton can be seen <http://milde.users.sourceforge.net/LUCR/Math/data/unimathsymbols.txt here>

Constructors

Record |

Fields

- uchar :: Char

  Unicode Character

- commands :: [(Text, Text)]

  LaTeX commands (package, command)

- category :: TeXSymbolType

  TeX math category

- comments :: Text

  Plain english description

#### Instances

Instances details

Show Record Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> Record -> ShowS Source # show :: Record -> String Source # showList :: [Record] -> ShowS Source #

type Property = Text Source #

data Position Source #

Constructors

Under |
Over |

data StrokeType Source #

Constructors

ForwardSlash |
BackSlash |
XSlash |

#### Instances

Instances details

Data StrokeType Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> StrokeType -> c StrokeType Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c StrokeType Source #

toConstr :: StrokeType -> Constr Source #

dataTypeOf :: StrokeType -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c StrokeType) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c StrokeType) Source #

gmapT :: (forall b. Data b => b -> b) -> StrokeType -> StrokeType Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> StrokeType -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> StrokeType -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> StrokeType -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> StrokeType -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> StrokeType -> m StrokeType Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> StrokeType -> m StrokeType Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> StrokeType -> m StrokeType Source #

Read StrokeType Source # |
Instance details Defined in Text.TeXMath.Types Methods readsPrec :: Int -> ReadS StrokeType Source # readList :: ReadS [StrokeType] Source # readPrec :: ReadPrec StrokeType Source # readListPrec :: ReadPrec [StrokeType] Source #
Show StrokeType Source # |
Instance details Defined in Text.TeXMath.Types Methods showsPrec :: Int -> StrokeType -> ShowS Source # show :: StrokeType -> String Source # showList :: [StrokeType] -> ShowS Source #
Eq StrokeType Source # |
Instance details Defined in Text.TeXMath.Types Methods (==) :: StrokeType -> StrokeType -> Bool Source # (/=) :: StrokeType -> StrokeType -> Bool Source #
Ord StrokeType Source # |

Instance details

Defined in Text.TeXMath.Types

Methods

compare :: StrokeType -> StrokeType -> Ordering Source #

(<) :: StrokeType -> StrokeType -> Bool Source #

(<=) :: StrokeType -> StrokeType -> Bool Source #

(>) :: StrokeType -> StrokeType -> Bool Source #

(>=) :: StrokeType -> StrokeType -> Bool Source #

max :: StrokeType -> StrokeType -> StrokeType Source #

min :: StrokeType -> StrokeType -> StrokeType Source #

type Env = [Text] Source #

List of available packages

defaultEnv :: [Text] Source #

Contains `amsmath` and `amssymbol`

type InEDelimited = Either Middle Exp Source #

An `EDelimited` element contains a string of ordinary expressions (represented here as `Right` values) or fences (represented here as `Left`, and in LaTeX using `mid`).